Index: trunk/src/lib/graphics/importer/static_model_data.h
===================================================================
--- trunk/src/lib/graphics/importer/static_model_data.h	(revision 9869)
+++ trunk/src/lib/graphics/importer/static_model_data.h	(revision 9869)
@@ -0,0 +1,177 @@
+/*!
+ * @file static_model.h
+ * @brief Contains the Model Class that handles Static 3D-Models rendered with glList's
+ */
+
+#ifndef _STATIC_MODEL_DATA_H
+#define _STATIC_MODEL_DATA_H
+
+#include "model.h"
+
+#include "material.h"
+#include <vector>
+#include "count_pointer.h"
+
+
+// definition of different modes for setting up Faces
+#define VERTEX 0       //!< If Faces are created WITH Vertex-Coordinate
+#define NORMAL 1       //!< If Faces are created WITH Normals (otherwise autocalculate)
+#define TEXCOORD 2     //!< If Faces are created WITH TextureCoordinate
+
+//! an enumerator for VERTEX_FORMAT
+typedef enum VERTEX_FORMAT {
+  VERTEX_ONLY = VERTEX,
+  VERTEX_NORMAL = NORMAL,
+  VERTEX_TEXCOORD = TEXCOORD,
+  VERTEX_TEXCOORD_NORMAL = NORMAL | TEXCOORD
+};
+
+////////////////////
+/// SUB-ELEMENTS ///
+////////////////////
+//! This is the placeholder of one Vertex beloning to a Face.
+class ModelFaceElement
+{
+public:
+  ModelFaceElement();
+  ~ModelFaceElement();
+
+  int                 vertexNumber;         //!< The number of the Vertex out of the Array* vertices, this vertex points to.
+  int                 normalNumber;         //!< The number of the Normal out of the Array* normals, this vertex points to.
+  int                 texCoordNumber;       //!< The number of the textureCoordinate out of the Array* vTexture, this vertex points to.
+
+  ModelFaceElement*   next;                 //!< Point to the next FaceElement in this List.
+};
+
+//! This is the placeholder of a Face belonging to a Group of Faces.
+class ModelFace
+{
+public:
+  ModelFace();
+  ~ModelFace();
+
+  unsigned int        vertexCount;     //!< The Count of vertices this Face has.
+  ModelFaceElement*   firstElem;       //!< Points to the first Vertex (FaceElement) of this Face.
+  Material*           material;        //!< The Material to use.
+
+  ModelFace*          next;            //!< Pointer to the next Face.
+};
+
+//! Group to handle multiple Models per obj-file.
+class ModelGroup
+{
+public:
+  ModelGroup();
+  ~ModelGroup();
+
+  void cleanup();
+
+  std::string  name;           //!< the Name of the Group. this is an identifier, that can be accessed via the draw (std::string name) function.
+  GLubyte*     indices;        //!< The indices of the Groups. Needed for vertex-arrays
+  GLuint       listNumber;     //!< The number of the GL-List this Group gets.
+  ModelFace*   firstFace;      //!< The first Face in this group.
+  ModelFace*   currentFace;    //!< The current Face in this Group (the one we are currently working with.)
+  int          faceMode;       //!< The Mode the Face is in: initially -1, 0 for FaceList opened, 1 for Material,  3 for triangle, 4 for Quad, 5+ for Poly @todo ENUM...
+  int          faceCount;      //!< The Number of Faces this Group holds.
+
+  ModelGroup*  next;           //!< Pointer to the next Group.
+};
+
+struct ModelMaterial
+{
+  Material* material;
+  bool external;
+};
+
+/////////////
+/// MODEL ///
+/////////////
+//! Class that handles static 3D-Models.
+/**
+ * it can also read them in and display them.
+ * All the objects are rendered with glLists
+ */
+class StaticModelData : public BaseObject
+{
+  ObjectListDeclaration(StaticModelData);
+  public:
+    typedef CountPointer<StaticModelData> Pointer;
+
+  public:
+  StaticModelData(const std::string& modelName = "");
+  virtual ~StaticModelData();
+
+  void draw() const;
+  void draw(int groupNumber) const;
+  void draw(const std::string& groupName) const;
+
+  void rebuild();
+
+  Material* addMaterial(Material* material);
+  Material* addMaterial(const std::string& materialName);
+
+  bool addGroup(const std::string& groupString);
+
+  void setScaleFactor(float scaleFactor) { this->scaleFactor = scaleFactor; };
+
+  bool addVertex(const std::string& vertexString);
+  bool addVertex(float x, float y, float z);
+
+  bool addFace(const std::string& faceString);
+  bool addFace(int faceElemCount, VERTEX_FORMAT type, va_list args);
+
+  bool addVertexNormal(const std::string& normalString);
+  bool addVertexNormal(float x, float y, float z);
+
+  bool addVertexTexture(const std::string& vTextureString);
+  bool addVertexTexture(float u, float v);
+
+  bool setMaterial(const std::string& mtlString);
+  bool setMaterial(Material* mtl);
+
+  void finalize();
+
+
+  const std::vector<GLfloat>& getVertices() const { return this->vertices; };
+  const std::vector<GLfloat>& getNormals() const { return this->normals; };
+  const std::vector<GLfloat>& getTexCoords() const { return this->vTexture; };
+  const std::vector<sTriangleExt>& getTriangles() const { return this->triangles; };
+  ///! HACK SOLUTION sTriangleExt should be const in the modelInfo.
+  sTriangleExt* getTrianglesExt() { return &this->triangles[0]; };
+
+  float getScaleFactor() const  { return scaleFactor; }
+
+protected:
+  Material* findMaterialByName(const std::string& materialName);
+
+private:
+  bool buildVertexNormals();
+
+  bool importToDisplayList();
+  bool buildTriangleList();
+
+  bool addGLElement(ModelFaceElement* elem);
+
+  bool cleanup();
+
+private:
+  bool                       finalized;       //!< Sets the Object to be finalized.
+
+  float                      scaleFactor;     //!< The Factor with which the Model should be scaled. @todo maybe one wants to scale the Model after Initialisation
+
+  unsigned int               faceCount;       //!< A modelwide Counter for the faces
+
+  std::vector<GLfloat>       vertices;        //!< The Array that handles the Vertices.
+  std::vector<GLfloat>       normals;         //!< The Array that handles the Normals.
+  std::vector<GLfloat>       vTexture;        //!< The Array that handles the VertexTextureCoordinates.
+
+  std::vector<sTriangleExt>  triangles;       //!< The Triangles if built.
+
+  ModelGroup*                firstGroup;      //!< The first of all groups.
+  ModelGroup*                currentGroup;    //!< The currentGroup. this is the one we will work with.
+  int                        groupCount;      //!< The Count of Groups.
+
+  std::list<ModelMaterial*>  materialList;    //!< A list for all the Materials in this Model
+};
+
+#endif /* _STATIC_MODEL_DATA_H */
Index: trunk/src/lib/graphics/importer/texture.cc
===================================================================
--- trunk/src/lib/graphics/importer/texture.cc	(revision 9682)
+++ trunk/src/lib/graphics/importer/texture.cc	(revision 9869)
@@ -64,5 +64,5 @@
 #endif
 
-
+ObjectListDefinition(Texture);
 
 /**
@@ -86,5 +86,5 @@
     : data(texture.data)
 {
-  this->setClassID(CL_TEXTURE, "Texture");
+  this->registerObject(this, Texture::_objectList);
   this->priority = 0.5;
 }
@@ -149,7 +149,7 @@
 void Texture::init()
 {
-  this->setClassID(CL_TEXTURE, "Texture");
-
-  this->data = TextureDataPointer(new TextureData());
+  this->registerObject(this, Texture::_objectList);
+
+  this->data = TextureData::Pointer(new TextureData());
 
   this->priority = 0.5;
@@ -176,5 +176,5 @@
 }
 
-Texture& Texture::operator=(const TextureDataPointer& textureDataPointer)
+Texture& Texture::operator=(const TextureData::Pointer& textureDataPointer)
 {
   this->data = textureDataPointer;
Index: trunk/src/lib/graphics/importer/texture.h
===================================================================
--- trunk/src/lib/graphics/importer/texture.h	(revision 9682)
+++ trunk/src/lib/graphics/importer/texture.h	(revision 9869)
@@ -1,5 +1,5 @@
 /*!
  * @file texture.h
- * @brief Contains the texture class, that handles the reading of Images into Texutre-files.
+ * @brief Contains the texture class, that handles the reading of Images into Texture-files.
  */
 
@@ -20,4 +20,5 @@
 class Texture : public BaseObject
 {
+  ObjectListDeclaration(Texture);
 public:
   Texture();
@@ -28,5 +29,7 @@
 
   Texture& operator=(const Texture& texture);
-  Texture& operator=(const TextureDataPointer& textureDataPointer);
+  Texture& operator=(const TextureData::Pointer& textureDataPointer);
+  void acquireData(const TextureData::Pointer& textureDataPointer) { this->data = textureDataPointer; };
+  const TextureData::Pointer& dataPointer() const { return data; }
 
   virtual ~Texture();
@@ -62,5 +65,5 @@
 
 private:
-  TextureDataPointer            data;               //!< The TextureData
+  TextureData::Pointer          data;               //!< The TextureData
   GLclampf                      priority;           //!< the priority of the current texture (used for garphics cards with limited mem)
 
Index: trunk/src/lib/graphics/importer/texture_data.h
===================================================================
--- trunk/src/lib/graphics/importer/texture_data.h	(revision 9682)
+++ trunk/src/lib/graphics/importer/texture_data.h	(revision 9869)
@@ -18,4 +18,6 @@
 class TextureData
 {
+  public:
+    typedef CountPointer<TextureData> Pointer;
   public:
     TextureData();
@@ -43,5 +45,3 @@
 };
 
-typedef CountPointer<TextureData> TextureDataPointer;
-
 #endif /* _TEXTURE_DATA_H */
Index: trunk/src/lib/graphics/importer/texture_sequence.cc
===================================================================
--- trunk/src/lib/graphics/importer/texture_sequence.cc	(revision 9682)
+++ trunk/src/lib/graphics/importer/texture_sequence.cc	(revision 9869)
@@ -28,4 +28,6 @@
 #endif
 
+ObjectListDefinition(TextureSequence);
+
 /**
  * @brief Constructor for a Texture
@@ -33,5 +35,5 @@
 TextureSequence::TextureSequence(unsigned int count, ...)
 {
-  this->setClassID(CL_TEXTURE_SEQUENCE, "TextureSequence");
+  this->registerObject(this, TextureSequence::_objectList);
 
   va_list textureNameList;
@@ -54,5 +56,5 @@
 TextureSequence::TextureSequence(const std::vector<std::string>& textureNames, const std::string& prependFolder)
 {
-  this->setClassID(CL_TEXTURE_SEQUENCE, "TextureSequence");
+  this->registerObject(this, TextureSequence::_objectList);
   this->loadImageSeries(textureNames, prependFolder);
 }
Index: trunk/src/lib/graphics/importer/texture_sequence.h
===================================================================
--- trunk/src/lib/graphics/importer/texture_sequence.h	(revision 9682)
+++ trunk/src/lib/graphics/importer/texture_sequence.h	(revision 9869)
@@ -15,4 +15,5 @@
 class TextureSequence : public Texture
 {
+  ObjectListDeclaration(TextureSequence);
   public:
     TextureSequence(unsigned int count = 0, ...);
Index: trunk/src/lib/graphics/importer/vertex_array_model.cc
===================================================================
--- trunk/src/lib/graphics/importer/vertex_array_model.cc	(revision 9682)
+++ trunk/src/lib/graphics/importer/vertex_array_model.cc	(revision 9869)
@@ -24,4 +24,5 @@
 
 
+ObjectListDefinition(VertexArrayModel);
 
 /////////////
@@ -35,5 +36,5 @@
 VertexArrayModel::VertexArrayModel()
 {
-  this->setClassID(CL_MODEL, "VertexArrayModel");
+  this->registerObject(this, VertexArrayModel::_objectList);
 
   this->newStripe();
@@ -49,5 +50,5 @@
 VertexArrayModel::VertexArrayModel(const Model& model)
 {
-  this->setClassID(CL_MODEL, "VertexArrayModel");
+  this->registerObject(this, VertexArrayModel::_objectList);
 
   // importing the data to the new Model.
Index: trunk/src/lib/graphics/importer/vertex_array_model.h
===================================================================
--- trunk/src/lib/graphics/importer/vertex_array_model.h	(revision 9682)
+++ trunk/src/lib/graphics/importer/vertex_array_model.h	(revision 9869)
@@ -27,5 +27,6 @@
 class VertexArrayModel : public Model
 {
- public:
+  ObjectListDeclaration(VertexArrayModel);
+  public:
   VertexArrayModel();
   VertexArrayModel(const Model& model);
Index: trunk/src/lib/graphics/light.cc
===================================================================
--- trunk/src/lib/graphics/light.cc	(revision 9682)
+++ trunk/src/lib/graphics/light.cc	(revision 9869)
@@ -22,10 +22,12 @@
 #include "glincl.h"
 #include "vector.h"
-#include "parser/tinyxml/tinyxml.h"
-#include "util/loading/load_param.h"
+#include "util/loading/load_param_xml.h"
 #include "util/loading/factory.h"
 #include "debug.h"
 
-CREATE_FACTORY(Light, CL_LIGHT);
+#include "class_id_DEPRECATED.h"
+
+ObjectListDefinitionID(Light, CL_LIGHT);
+CREATE_FACTORY(Light);
 
 //! Definition of the Lights and their Names
@@ -51,7 +53,8 @@
   PRINTF(4)("initializing Light number %d.\n", this->lightNumber);
 
+  this->registerObject(this, Light::_objectList);
+
   this->lightNumber = LightManager::getInstance()->registerLight(this);
 
-  this->setClassID(CL_LIGHT, "Light");
   char tmpName[10];
   sprintf(tmpName, "Light[%d]", this->lightNumber);
@@ -211,4 +214,5 @@
 ** LIGHT-MANAGER **
 ******************/
+ObjectListDefinition(LightManager);
 /**
  *  standard constructor for a Light
@@ -216,5 +220,5 @@
 LightManager::LightManager ()
 {
-  this->setClassID(CL_LIGHT_MANAGER, "LightManager");
+  this->registerObject(this, LightManager::_objectList);
 
   glEnable (GL_LIGHTING);
Index: trunk/src/lib/graphics/light.h
===================================================================
--- trunk/src/lib/graphics/light.h	(revision 9682)
+++ trunk/src/lib/graphics/light.h	(revision 9869)
@@ -25,38 +25,39 @@
 class Light : public PNode
 {
-	public:
-		Light(const TiXmlElement* root = NULL);
-		virtual ~Light();
-		
-		virtual void loadParams(const TiXmlElement* root);
-		
-		void setDiffuseColor(GLfloat r, GLfloat g, GLfloat b);
-		void setSpecularColor(GLfloat r, GLfloat g, GLfloat b);
-		void setAttenuation(float constantAttenuation, float linearAttenuation, float quadraticAttenuation);
-		void setSpotDirection(const Vector& direction);
-		void setSpotDirection(float x, float y, float z) { setSpotDirection(Vector(x,y,z)); };
-		void setSpotCutoff(GLfloat cutoff);
-		
-		/** @returns the lightNumber*/
-		int getLightNumber() const {return this->lightNumber;}
-		
-		virtual void draw() const;
-		
-		void debug() const;
-	
-	// attributes
-	private:
-		int              lightNumber;               //!< The number of this Light.
-		GLfloat          diffuseColor[4];           //!< The Diffuse Color this Light emmits.
-		GLfloat          specularColor[4];          //!< The specular Color of this Light.
-		float            constantAttenuation;       //!< The Factor of the the Constant Attenuation.
-		float            linearAttenuation;         //!< The Factor of the the Linear Attenuation.
-		float            quadraticAttenuation;      //!< The Factor of the the Quadratic Attenuation.
-		GLfloat          spotDirection[4];          //!< The direction of the Spot Light.
-		GLfloat          spotCutoff;                //!< The cutoff Angle of the Light Source
+  ObjectListDeclaration(Light);
+public:
+  Light(const TiXmlElement* root = NULL);
+  virtual ~Light();
+
+  virtual void loadParams(const TiXmlElement* root);
+
+  void setDiffuseColor(GLfloat r, GLfloat g, GLfloat b);
+  void setSpecularColor(GLfloat r, GLfloat g, GLfloat b);
+  void setAttenuation(float constantAttenuation, float linearAttenuation, float quadraticAttenuation);
+  void setSpotDirection(const Vector& direction);
+  void setSpotDirection(float x, float y, float z) { setSpotDirection(Vector(x,y,z)); };
+  void setSpotCutoff(GLfloat cutoff);
+
+  /** @returns the lightNumber*/
+  int getLightNumber() const {return this->lightNumber;}
+
+  virtual void draw() const;
+
+  void debug() const;
+
+  // attributes
+private:
+  int              lightNumber;               //!< The number of this Light.
+  GLfloat          diffuseColor[4];           //!< The Diffuse Color this Light emmits.
+  GLfloat          specularColor[4];          //!< The specular Color of this Light.
+  float            constantAttenuation;       //!< The Factor of the the Constant Attenuation.
+  float            linearAttenuation;         //!< The Factor of the the Linear Attenuation.
+  float            quadraticAttenuation;      //!< The Factor of the the Quadratic Attenuation.
+  GLfloat          spotDirection[4];          //!< The direction of the Spot Light.
+  GLfloat          spotCutoff;                //!< The cutoff Angle of the Light Source
 };
-	
-	
-	
+
+
+
 //! A class that handles Lights
 /**
@@ -87,38 +88,39 @@
 */
 class LightManager : public BaseObject
-	{
-	friend class Light;
+{
+  ObjectListDeclaration(LightManager);
 
-	public:
-		virtual ~LightManager();
-		/** @returns a Pointer to the only object of this Class */
-		inline static LightManager* getInstance() { if (!singletonRef) singletonRef = new LightManager();  return singletonRef; };
+  friend class Light;
+public:
+  virtual ~LightManager();
+  /** @returns a Pointer to the only object of this Class */
+  inline static LightManager* getInstance() { if (!singletonRef) singletonRef = new LightManager();  return singletonRef; };
 
-		virtual void loadParams(const TiXmlElement* root);
-		void loadLights(const TiXmlElement* root);
+  virtual void loadParams(const TiXmlElement* root);
+  void loadLights(const TiXmlElement* root);
 
-		void setAmbientColor(GLfloat r, GLfloat g, GLfloat b);
-		// HACK: Assuming r = g = b values
-		inline GLfloat getAmbientColor() {  return this->ambientColor[0]; }
+  void setAmbientColor(GLfloat r, GLfloat g, GLfloat b);
+  // HACK: Assuming r = g = b values
+inline GLfloat getAmbientColor() {  return this->ambientColor[0]; }
 
-		Light* getLight(int lightNumber) const;
-		inline Light* getLight() const { return this->currentLight; };
+  Light* getLight(int lightNumber) const;
+  inline Light* getLight() const { return this->currentLight; };
 
-		void draw() const;
+  void draw() const;
 
-		void debug() const;
+  void debug() const;
 
-	private:
-		LightManager();
+private:
+  LightManager();
 
-		int  registerLight(Light* light);
-		void unregisterLight(Light* light);
+  int  registerLight(Light* light);
+  void unregisterLight(Light* light);
 
-	private:
-		static LightManager*    singletonRef;       //!< This is the LightHandlers Reference.
-		GLfloat                 ambientColor[4];    //!< The ambient Color of the scene.
+private:
+  static LightManager*    singletonRef;       //!< This is the LightHandlers Reference.
+  GLfloat                 ambientColor[4];    //!< The ambient Color of the scene.
 
-		Light**                 lights;             //!< An array of Lenght NUMBEROFLIGHTS, that holds pointers to all LightValues.
-		Light*                  currentLight;       //!< The current Light, we are working with.
+  Light**                 lights;             //!< An array of Lenght NUMBEROFLIGHTS, that holds pointers to all LightValues.
+  Light*                  currentLight;       //!< The current Light, we are working with.
 
 };
Index: trunk/src/lib/graphics/render2D/element_2d.cc
===================================================================
--- trunk/src/lib/graphics/render2D/element_2d.cc	(revision 9682)
+++ trunk/src/lib/graphics/render2D/element_2d.cc	(revision 9869)
@@ -29,10 +29,12 @@
 #include "graphics_engine.h"
 #include "util/loading/load_param.h"
-#include "class_list.h"
 
 #include "color.h"
-
+#include "debug.h"
 #include "shell_command.h"
+
 SHELL_COMMAND(debug, Element2D, debug2D);
+
+ObjectListDefinition(Element2D);
 
 
@@ -46,5 +48,5 @@
 Element2D::Element2D (Element2D* parent, E2D_LAYER layer, short nodeFlags)
 {
-  this->setClassID(CL_ELEMENT_2D, "Element2D");
+  this->registerObject(this, Element2D::_objectList);
 
   this->setVisibility(true);
@@ -268,5 +270,5 @@
 void Element2D::setBindNode(const std::string& bindNode)
 {
-  const PNode* tmpBindNode = dynamic_cast<const PNode*>(ClassList::getObject(bindNode, CL_PARENT_NODE));
+  const PNode* tmpBindNode = PNode::objectList().getObject(bindNode);
   if (tmpBindNode != NULL)
     this->bindNode = tmpBindNode;
@@ -640,5 +642,5 @@
 void Element2D::addChild2D (const std::string& childName)
 {
-  Element2D* childNode = dynamic_cast<Element2D*>(ClassList::getObject(childName, CL_ELEMENT_2D));
+  Element2D* childNode = Element2D::objectList().getObject(childName);
   if (childNode != NULL)
     this->addChild2D(childNode);
@@ -718,5 +720,5 @@
 void Element2D::setParent2D (const std::string& parentName)
 {
-  Element2D* parentNode = dynamic_cast<Element2D*>(ClassList::getObject(parentName, CL_ELEMENT_2D));
+  Element2D* parentNode = Element2D::objectList().getObject(parentName);
   if (parentNode != NULL)
     parentNode->addChild2D(this);
@@ -771,5 +773,5 @@
 void Element2D::setParentSoft2D(const std::string& parentName, float bias)
 {
-  Element2D* parentNode = dynamic_cast<Element2D*>(ClassList::getObject(parentName, CL_ELEMENT_2D));
+  Element2D* parentNode = Element2D::objectList().getObject(parentName);
   if (parentNode != NULL)
     this->setParentSoft2D(parentNode, bias);
